#!/usr/bin/env python

# Creator: TT
# Open Source fx_stencil 0.1,30,100,5,0,0,0,50,50

# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html

from gimpfu import *
import gtk, gimpui
gimpui.gimp_ui_init ()  # add MrQ

# Global variables to store the parameters used for our effect/work to show preview or actual layer when user OK it
global_param1 = 0 #in this example it's radius
global_param2 = 0   #in this example it's feather_radius
global_param3 = 0  #in this example it's iterations
global_param4 = 0   #in this example it's enhance_shadows
global_param5 = 0  #in this example it's iterations
global_param6 = 0 
chosen_color = 0
sample_integer = 13
image = 0 #we'll set these when dialog() is called so that we can access them later
drawable = 0
has_preview = False
preview_layer = 0
#for this operation
selection_channel = 0
proceed_with_changes = False
proceed_with_changes_p = False
def apply_effect(layer): #function to do work on either preview layer or actual drawable when user clicks OK
    global image

    radius = global_param1
    smoothness = global_param2
    iterations = global_param3
    aliasing = global_param4
	
    if proceed_with_changes==0:	
        transparency=0
    if proceed_with_changes==1:	
        transparency=1
# option model active_iter selected_option 	


    if selected_option== "Black & White" :
        stencil_type=0
    #if selected_option== "RGB" :	# not 
        #stencil_type=1		
    if selected_option== "Color" :
        stencil_type=2
		
    #pdb.plug_in_gmic_qt(image, layer, 1, 0, 'deform ' + str(amplitude))   fx_stencil 0,30,2,5,2,0,0,50,50  fx_stencil 0,30,2,5,2,1,0,50,50
    pdb.plug_in_gmic_qt(image, layer, 1, 0, 'fx_stencil ' + str(radius) + "," + str(smoothness) + "," + str(iterations) + "," + str(aliasing) + "," +  str(stencil_type) + "," +  str(transparency) + ',0,50,50')
    #pdb.plug_in_gmic_qt(image, layer, 1, 0,  'fx_stencil ' + str(radius) + "," + str(smoothness) + "," + str(iterations) + "," + str(aliasing) + "," +  str(stencil_type) + "," +  str(transparency) + ',0,50,50')
    #pdb.plug_in_gmic_qt(image, layer, 1, 0, 'fx_stencil 0,30,2,5,2,0,0,50,50')
    gimp.displays_flush()

def apply_final(layer): #wrapper to apply effect on final and remove preview_layer meant to be called by on_ok_button_clicked
    global preview_layer
    if has_preview:
        pdb.gimp_image_remove_layer(image,preview_layer)

    pdb.gimp_image_undo_enable(image) #so that user can undo this next step
    pdb.gimp_image_undo_group_start(image) #so it's undone in Ctrl+Z
    #if proceed_with_changes_p==0:
    if proceed_with_changes_p==1:	
        apply_effect(preview_layer)
	 	

	
    pdb.gimp_image_undo_group_end(image)
   

# Function to update the live preview
def update_live_preview(): #this is called everytime some parameter changes
    global global_param1,global_param2, global_param3, global_param4
    global image,drawable
    global has_preview,preview_layer #deal with preview layer
   
    # Apply your plugin's effect using the current parameters
    # Use global_param1 and global_param2 to access the user's inputs
    if not has_preview: #create a preview layer
        #pdb.gimp_message("Creating preview")
        preview_layer = pdb.gimp_layer_new_from_drawable(drawable,image)
        pdb.gimp_image_insert_layer(image,preview_layer,None,0) #insert top most so we see it
        has_preview = True #now set it true so we can deal with existing layer in later calls
    else: # already have preview layer
        #pdb.gimp_message("Removing existing and creating new Preview")
        pdb.gimp_image_remove_layer(image,preview_layer) #remove it to create a new one to work on
        preview_layer = pdb.gimp_layer_new_from_drawable(drawable,image)
        pdb.gimp_image_insert_layer(image,preview_layer,None,0) #insert top most so we see it
    if proceed_with_changes_p==1:
        apply_effect(preview_layer)
 
    # Update the live preview layer with the modified image
   
def dialog(image_, drawable_):
    global image, drawable
    #save these for updates
    image = image_
    pdb.gimp_image_undo_disable(image) #for speed and also when user undo it doesn't see our preview creations/deletions
    drawable = drawable_ 

    dialog = gtk.Dialog("G'MIC - Stencil Live Preview", None, gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT)
    dialog.set_default_size(400, 100)

    #-------------------------------------------------------------
    hbox1 = gtk.HBox()
    dialog.vbox.pack_start(hbox1, expand=True, fill=True)
    label1 = gtk.Label("Radius:         ")
    hbox1.pack_start(label1, expand=False, fill=False, padding=5)
    adjustment1 = gtk.Adjustment(value=3, lower=0, upper=10, step_incr=1, page_incr=0)
    param1_scale = gtk.HScale(adjustment=adjustment1)
    param1_scale.set_digits(0)  # Display only integers
    hbox1.pack_start(param1_scale, expand=True, fill=True, padding=5)
    param1_scale.connect("value-changed", on_param1_changed)

    #-------------------------------------------------------------
    hbox2 = gtk.HBox()
    dialog.vbox.pack_start(hbox2, expand=True, fill=True)
    label2 = gtk.Label("Smoothness:")
    hbox2.pack_start(label2, expand=False, fill=False, padding=5)
    adjustment2 = gtk.Adjustment(value=30, lower=0, upper=30, step_incr=1, page_incr=0)
    param2_scale = gtk.HScale(adjustment=adjustment2)
    param2_scale.set_digits(0)  # Display only integers
    hbox2.pack_start(param2_scale, expand=True, fill=True, padding=5)
    param2_scale.connect("value-changed", on_param2_changed)

    #-------------------------------------------------------------
    #-------------------------------------------------------------
    hbox3 = gtk.HBox()
    dialog.vbox.pack_start(hbox3, expand=True, fill=True)
    label3 = gtk.Label("Iterations:     ")
    hbox3.pack_start(label3, expand=False, fill=False, padding=5)
    adjustment3 = gtk.Adjustment(value=2, lower=0, upper=100, step_incr=1, page_incr=0)
    param3_scale = gtk.HScale(adjustment=adjustment3)
    param3_scale.set_digits(0)  # Display only integers
    hbox3.pack_start(param3_scale, expand=True, fill=True, padding=5)
    # Connect callback functions for user interaction
    param3_scale.connect("value-changed", on_param3_changed)

    #-------------------------------------------------------------
	
    hbox4 = gtk.HBox()
    dialog.vbox.pack_start(hbox4, expand=True, fill=True)
    label4 = gtk.Label("Aliasing:        ")
    hbox4.pack_start(label4, expand=False, fill=False, padding=5)
    adjustment4 = gtk.Adjustment(value=5, lower=0, upper=5, step_incr=1, page_incr=0)
    param4_scale = gtk.HScale(adjustment=adjustment4)
    param4_scale.set_digits(0)  # Display only integers
    hbox4.pack_start(param4_scale, expand=True, fill=True, padding=5)
    # Connect callback functions for user interaction
    param4_scale.connect("value-changed", on_param4_changed)
    #-------------------------------------------------------------

   #Combo box ===================================
    hbox7 = gtk.HBox()
    dialog.vbox.pack_start(hbox7, expand=True, fill=True)

    label7 = gtk.Label("Stencil Type:  ")
    hbox7.pack_start(label7, expand=False, fill=False, padding=5)   


    # Create a ComboBox
    combo_box = gtk.ComboBox()
    hbox7.pack_start(combo_box, expand=False, fill=False, padding=5)

    # Create a ListStore model for ComboBox
    list_store = gtk.ListStore(str)
    options = ["Black & White","Color"]  # Add your options here
    for option in options:
        list_store.append([option])

    # Set the model for ComboBox
    combo_box.set_model(list_store)

    # Create a CellRendererText to render the text in the ComboBox
    cell_renderer = gtk.CellRendererText()

    # Pack the CellRendererText into the ComboBox
    combo_box.pack_start(cell_renderer, True)
    combo_box.add_attribute(cell_renderer, 'text', 0)

    # Set up the "changed" signal handler   
    combo_box.connect("changed", on_combobox_changed)

    # Set the default option to "Option 1" ======================================
    default_option = "Color"
    default_iter = list_store.get_iter_first()
    while default_iter is not None:
        if list_store.get_value(default_iter, 0) == default_option:
            combo_box.set_active_iter(default_iter)
            break
        default_iter = list_store.iter_next(default_iter)
    #===========================================================================

    #toggle button ==============
    hbox6 = gtk.HBox()
    dialog.vbox.pack_start(hbox6, expand=True, fill=True)

    label6 = gtk.Label("Transparency:")
    hbox6.pack_start(label6, expand=False, fill=False, padding=5)   
    toggle_button = gtk.ToggleButton()

    # Set initial label
    update_toggle_button_label(toggle_button)
    # Connect the toggle event
    toggle_button.connect("toggled", on_toggle_button_toggled)
    hbox6.pack_start(toggle_button, expand=False, fill=False, padding=5) 
	
    #===========================================================================
    hbox9 = gtk.HBox()
    dialog.vbox.pack_start(hbox9, expand=True, fill=True)

    label9 = gtk.Label("                                           Preview:")
    hbox9.pack_start(label9, expand=True, fill=False, padding=5)   
    toggle_p = gtk.ToggleButton()

    # Set initial label
    update_toggle_button_label_p(toggle_p)
    # Connect the toggle event
    toggle_p.connect("toggled", on_toggle_button_toggled_p)
    hbox9.pack_start(toggle_p, expand=True, fill=True, padding=5)  
    #===========================================================================
    # Add an CANCEL button
    cancel_buton = dialog.add_button(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL)
    cancel_buton.connect("clicked", cancel)
	
    # Add an OK button
    ok_button = dialog.add_button(gtk.STOCK_OK, gtk.RESPONSE_OK)
    ok_button.connect("clicked", on_ok_button_clicked)

	
    # Show the dialog
    dialog.show_all()
    #update_live_preview() #call this once so we see effect
    dialog.run()
	
	
def cancel(cancel_buton, data=None):
    global preview_layer
    pdb.gimp_image_remove_layer(image,preview_layer)

# Callback function for updating the live preview when param1 changes
def on_param1_changed(scale):
    global global_param1
    global_param1 = scale.get_value()
    update_live_preview()
def on_param2_changed(scale):
    global global_param2
    global_param2 = scale.get_value()
    update_live_preview()
def on_param3_changed(scale):
    global global_param3
    global_param3 = scale.get_value()
    update_live_preview()	
def on_param4_changed(scale):
    global global_param4
    global_param4 = scale.get_value()
    update_live_preview()	
	
# Callback function for the OK buttonselected_

def on_combobox_changed(combobox):
    global selected_option
    model = combobox.get_model()
    active_iter = combobox.get_active_iter()

    if active_iter:
        selected_option = model.get_value(active_iter, 0)
    update_live_preview()
	
def on_toggle_button_toggled(button):
    global proceed_with_changes
    proceed_with_changes = not proceed_with_changes
    update_toggle_button_label(button)

def update_toggle_button_label(button):
    label = "Yes" if proceed_with_changes else "No"
    button.set_label(label)	
    update_live_preview()	
#######################################################
def on_toggle_button_toggled_p(button):
    global proceed_with_changes_p
    proceed_with_changes_p = not proceed_with_changes_p
    update_toggle_button_label_p(button)

def update_toggle_button_label_p(button):
    label = "Yes" if proceed_with_changes_p else "No"
    button.set_label(label)	
    update_live_preview()	

#######################################################	
def on_ok_button_clicked(button, data=None):
    global drawable
    #apply_final(drawable)
    button.get_toplevel().destroy() #destroys the gtk dialog window
# Register the Python-Fu plugin

register(
    "python_fu_gmic_stencil_live_preview_test",
    "Live Preview Plugin",
    "Create a live preview of an effect",
    "Tin Tran/MrQ",
    "GPL3",
    "2023",
    "<Image>/Python-Fu/Live Preview/G'MIC - Stencil Live Preview",  # Menu location
    "*",  # Image type
    [],
    [],
    dialog
)

main()